// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_geometry_msgs:msg/LineSegment.idl
// generated code does not contain a copyright notice
#include "tuw_geometry_msgs/msg/detail/line_segment__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `p0`
// Member `p1`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
tuw_geometry_msgs__msg__LineSegment__init(tuw_geometry_msgs__msg__LineSegment * msg)
{
  if (!msg) {
    return false;
  }
  // id
  // p0
  if (!geometry_msgs__msg__Point__init(&msg->p0)) {
    tuw_geometry_msgs__msg__LineSegment__fini(msg);
    return false;
  }
  // p1
  if (!geometry_msgs__msg__Point__init(&msg->p1)) {
    tuw_geometry_msgs__msg__LineSegment__fini(msg);
    return false;
  }
  return true;
}

void
tuw_geometry_msgs__msg__LineSegment__fini(tuw_geometry_msgs__msg__LineSegment * msg)
{
  if (!msg) {
    return;
  }
  // id
  // p0
  geometry_msgs__msg__Point__fini(&msg->p0);
  // p1
  geometry_msgs__msg__Point__fini(&msg->p1);
}

bool
tuw_geometry_msgs__msg__LineSegment__are_equal(const tuw_geometry_msgs__msg__LineSegment * lhs, const tuw_geometry_msgs__msg__LineSegment * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // p0
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->p0), &(rhs->p0)))
  {
    return false;
  }
  // p1
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->p1), &(rhs->p1)))
  {
    return false;
  }
  return true;
}

bool
tuw_geometry_msgs__msg__LineSegment__copy(
  const tuw_geometry_msgs__msg__LineSegment * input,
  tuw_geometry_msgs__msg__LineSegment * output)
{
  if (!input || !output) {
    return false;
  }
  // id
  output->id = input->id;
  // p0
  if (!geometry_msgs__msg__Point__copy(
      &(input->p0), &(output->p0)))
  {
    return false;
  }
  // p1
  if (!geometry_msgs__msg__Point__copy(
      &(input->p1), &(output->p1)))
  {
    return false;
  }
  return true;
}

tuw_geometry_msgs__msg__LineSegment *
tuw_geometry_msgs__msg__LineSegment__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geometry_msgs__msg__LineSegment * msg = (tuw_geometry_msgs__msg__LineSegment *)allocator.allocate(sizeof(tuw_geometry_msgs__msg__LineSegment), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_geometry_msgs__msg__LineSegment));
  bool success = tuw_geometry_msgs__msg__LineSegment__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_geometry_msgs__msg__LineSegment__destroy(tuw_geometry_msgs__msg__LineSegment * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_geometry_msgs__msg__LineSegment__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_geometry_msgs__msg__LineSegment__Sequence__init(tuw_geometry_msgs__msg__LineSegment__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geometry_msgs__msg__LineSegment * data = NULL;

  if (size) {
    data = (tuw_geometry_msgs__msg__LineSegment *)allocator.zero_allocate(size, sizeof(tuw_geometry_msgs__msg__LineSegment), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_geometry_msgs__msg__LineSegment__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_geometry_msgs__msg__LineSegment__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_geometry_msgs__msg__LineSegment__Sequence__fini(tuw_geometry_msgs__msg__LineSegment__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_geometry_msgs__msg__LineSegment__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_geometry_msgs__msg__LineSegment__Sequence *
tuw_geometry_msgs__msg__LineSegment__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_geometry_msgs__msg__LineSegment__Sequence * array = (tuw_geometry_msgs__msg__LineSegment__Sequence *)allocator.allocate(sizeof(tuw_geometry_msgs__msg__LineSegment__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_geometry_msgs__msg__LineSegment__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_geometry_msgs__msg__LineSegment__Sequence__destroy(tuw_geometry_msgs__msg__LineSegment__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_geometry_msgs__msg__LineSegment__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_geometry_msgs__msg__LineSegment__Sequence__are_equal(const tuw_geometry_msgs__msg__LineSegment__Sequence * lhs, const tuw_geometry_msgs__msg__LineSegment__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_geometry_msgs__msg__LineSegment__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_geometry_msgs__msg__LineSegment__Sequence__copy(
  const tuw_geometry_msgs__msg__LineSegment__Sequence * input,
  tuw_geometry_msgs__msg__LineSegment__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_geometry_msgs__msg__LineSegment);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_geometry_msgs__msg__LineSegment * data =
      (tuw_geometry_msgs__msg__LineSegment *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_geometry_msgs__msg__LineSegment__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_geometry_msgs__msg__LineSegment__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_geometry_msgs__msg__LineSegment__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
